<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__syslib" kind="group">
    <compoundname>group_syslib</compoundname>
    <title>SysLib       (System Library)</title>
    <innergroup refid="group__group__syslib__macros">Macros</innergroup>
    <innergroup refid="group__group__syslib__functions">Functions</innergroup>
    <innergroup refid="group__group__syslib__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__syslib__enumerated__types">Enumerated Types</innergroup>
    <briefdescription>
<para>The system libraries provide APIs that can be called in the user application to handle the timing, logical checking or register. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_syslib.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The SysLib driver contains a set of different system functions. These functions can be called in the application routine. Major features of the system library:<itemizedlist>
<listitem><para>Delay functions</para></listitem><listitem><para>The register Read/Write macro</para></listitem><listitem><para>Assert and Halt</para></listitem><listitem><para>Assert Classes and Levels</para></listitem><listitem><para>A software reset</para></listitem><listitem><para>Reading the reset cause</para></listitem><listitem><para>An API to invalidate the flash cache and buffer</para></listitem><listitem><para>Data manipulation macro</para></listitem><listitem><para>A variable type definition from MISRA-C which specifies signedness</para></listitem><listitem><para>Cross compiler compatible attributes</para></listitem><listitem><para>Getting a silicon-unique ID API</para></listitem><listitem><para>Setting wait states API</para></listitem><listitem><para>Resetting the backup domain API</para></listitem><listitem><para>APIs to serve Fault handler</para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para><bold> Assertion Usage </bold> <linebreak />
 Use the CY_ASSERT() macro to check expressions that must be true as long as the program is running correctly. It is a convenient way to insert sanity checks. The CY_ASSERT() macro is defined in the cy_syslib.h file which is part of the PDL library. The behavior of the macro is as follows: if the expression passed to the macro is false, output an error message that includes the file name and line number, and then halts the CPU. <linebreak />
In case of fault, the CY_ASSERT() macro calls the <ref kindref="member" refid="group__group__syslib__functions_1ga0fe70e0948f5d2b2fb1615b85b0d7d7a">Cy_SysLib_AssertFailed()</ref> function. This is a weakly linked function. The default implementation stores the file name and line number of the ASSERT into global variables, cy_assertFileName and cy_assertLine . It then calls the <ref kindref="member" refid="group__group__syslib__functions_1gaaf5ef74a64fe1abbc195da55e4acf075">Cy_SysLib_Halt()</ref> function. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Firmware can redefine the &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga0fe70e0948f5d2b2fb1615b85b0d7d7a"&gt;Cy_SysLib_AssertFailed()&lt;/a&gt; function for custom processing.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;The PDL source code uses this assert mechanism extensively. It is recommended that you enable asserts when debugging firmware. </verbatim><linebreak />
<bold> Assertion Classes and Levels </bold> <linebreak />
 The PDL defines three assert classes, which correspond to different kinds of parameters. There is a corresponding assert "level" for each class. <verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Class Macro&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Level Macro&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Type of check &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_CLASS_1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_L1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A parameter that could change between different PSoC devices (e.g. the number of clock paths)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_CLASS_2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_L2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A parameter that has fixed limits such as a counter period  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_CLASS_3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;CY_ASSERT_L3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A parameter that is an enum constant  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;Firmware defines which ASSERT class is enabled by defining CY_ASSERT_LEVEL. This is a compiler command line argument, similar to how the DEBUG / NDEBUG macro is passed. </verbatim><linebreak />
Enabling any class also enables any lower-numbered class. CY_ASSERT_CLASS_3 is the default level, and it enables asserts for all three classes. The following example shows the command-line option to enable all the assert levels: <programlisting><codeline><highlight class="normal">-D<sp />CY_ASSERT_LEVEL=CY_ASSERT_CLASS_3<sp /></highlight></codeline>
</programlisting> <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The use of special characters, such as spaces, parenthesis, etc. must be protected with quotes.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;After CY_ASSERT_LEVEL is defined, firmware can use one of the three level macros to make an assertion. For example, if the parameter can vary between devices, firmware uses the L1 macro. </verbatim><programlisting><codeline><highlight class="normal">CY_ASSERT_L1(clkPath<sp />&lt;<sp />SRSS_NUM_CLKPATH);<sp /></highlight></codeline>
</programlisting> If the parameter has bounds, firmware uses L2. <programlisting><codeline><highlight class="normal">CY_ASSERT_L2(trim<sp />&lt;=<sp />CY_CTB_TRIM_VALUE_MAX);<sp /></highlight></codeline>
</programlisting> If the parameter is an enum, firmware uses L3. <programlisting><codeline><highlight class="normal">CY_ASSERT_L3(config-&gt;LossAction<sp />&lt;=<sp />CY_SYSCLK_CSV_ERROR_FAULT_RESET);<sp /></highlight></codeline>
</programlisting> Each check uses the appropriate level macro for the kind of parameter being checked. If a particular assert class/level is not enabled, then the assert does nothing.</para>

<para><heading level="1">More Information</heading></para>
<para>Refer to the technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This function contains a mixture of in-line assembler statements and C statements. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This si required by design of the Cy_SysLib_Halt function.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;18.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Unions shall not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The unions are used for CFSR, HFSR and SHCSR Fault Status Registers content access as a word in code and as a structure during debug.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.60 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated the following functions for the PSoC 64 devices: &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga1691f4df41994e7ed9c30ec6495d925f"&gt;Cy_SysLib_ClearFlashCacheAndBuffer&lt;/a&gt;, &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1gaebb4e952584f0c428f58f7b4dbd3ceff"&gt;Cy_SysLib_ClearResetReason&lt;/a&gt;, &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added PSoC 64 device support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.50.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Add section Known Issues &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.50.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Used the core library defines for the message codes forming. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve PDL code base.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.50 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Moved following macros to the core library: CY_LO8,CY_HI8,CY_LO16,CY_HI16,CY_SWAP_ENDIAN16,CY_SWAP_ENDIAN32, CY_SWAP_ENDIAN64,CY_GET_REG8,CY_SET_REG8,CY_GET_REG16,CY_SET_REG16, CY_GET_REG24,CY_SET_REG24,CY_GET_REG32,CY_SET_REG32,_CLR_SET_FLD32U, CY_REG32_CLR_SET,_CLR_SET_FLD16U,CY_REG16_CLR_SET,_CLR_SET_FLD8U, CY_REG8_CLR_SET,_BOOL2FLD,_FLD2BOOL,CY_SYSLIB_DIV_ROUND, CY_SYSLIB_DIV_ROUNDUP,CY_NOINIT,CY_SECTION,CY_UNUSED,CY_NOINLINE, CY_ALIGN,CY_RAMFUNC_BEGIN,CY_RAMFUNC_END. Use at least version 1.1 of the core library: &lt;a href="https://github.com/cypresssemiconductorco/core-lib"&gt;https://github.com/cypresssemiconductorco/core-lib&lt;/a&gt;. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve PDL code base.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.40.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Correct the CY_RAMFUNC_BEGIN macro for the IAR compiler. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Removed the IAR compiler warning.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added new macros CY_SYSLIB_DIV_ROUND and CY_SYSLIB_DIV_ROUNDUP to easy perform integer division with rounding. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve PDL code base.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;2.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated implementation of the Cy_SysLib_AsmInfiniteLoop() function to be compatible with ARMC6. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Provided support for the ARM Compiler 6.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation edits. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added new macros CY_RAMFUNC_BEGIN and CY_RAMFUNC_END for convenient placement function in RAM for all supported compilers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve user experience.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated implementation of the &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga0fe70e0948f5d2b2fb1615b85b0d7d7a"&gt;Cy_SysLib_AssertFailed()&lt;/a&gt; function to be available in Release and Debug modes. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Provided support for the PDL static library in Release mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation edits. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the following macros: CY_REG32_CLR_SET, _CLR_SET_FLD16U, CY_REG16_CLR_SET, _CLR_SET_FLD8U, CY_REG8_CLR_SET &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Register access simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed the Cy_SysLib_GetNumHfclkResetCause API function. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;This feature is not supported by SRSS_ver1.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation edits &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1gadb2c8e123ba3a0376a14871e58230321"&gt;Cy_SysLib_ResetBackupDomain()&lt;/a&gt; API implementation. &lt;br /&gt;Added CY_NOINLINE attribute implementation. &lt;br /&gt;Added DIE_YEAR field to 64-bit unique ID return value of &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1gaaa8fb5b7a16fbdfd60cf44d5d8f2c977"&gt;Cy_SysLib_GetUniqueId()&lt;/a&gt; API. &lt;br /&gt;Added storing of SCB-&amp;gt;HFSR, SCB-&amp;gt;SHCSR registers and SCB-&amp;gt;MMFAR, SCB-&amp;gt;BFAR addresses to Fault Handler debug structure. &lt;br /&gt;Optimized &lt;a href="group__group__syslib__functions.html#group__group__syslib__functions_1ga8b897f8554957f9393f645d5ab1106c9"&gt;Cy_SysLib_SetWaitStates()&lt;/a&gt; API implementation.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improvements made based on usability feedback.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added Assertion Classes and Levels. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;For error checking, parameter validation and status returns in the PDL API.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Applied CY_NOINIT attribute to cy_assertFileName, cy_assertLine, and cy_faultFrame global variables. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To store debug information into a non-zero init area for future analysis.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed CY_WEAK attribute implementation. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;CMSIS __WEAK attribute should be used instead.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>